@echo off

set Saxon8Dir=p:\xml\xslt\saxon8\
set AntDir=p:\apache\ant\
set OpenOfficeRun=p:\OpenOffice.org 2.0\program\soffice.exe

goto :start
:message

echo.
echo  Invocation of the Ant process to orchestrate the Ant script that
echo  choreographs the execution of all of the required dependency checks
echo  and invocations:
echo.  
echo   %%1 = "strict" or "permitted"
echo   %%2 = document spreadsheet base filename (no extension)
echo   %%3 = document spreadsheet file extension (ods or xls)
echo   %%4 = XSD input file to be pruned to create the output
echo   %%5 = XSD output pruned file
echo   %%6 = component (e.g. "Invoice" or "CommonAggregateComponents")
echo   %%7 = work/intermediate directory
echo   %%8 = copyright file
echo   %%9 = foreign column prefix expressed as a regular expression
echo   %%10 = foreign output namespace URI
echo   %%11 = error file
echo.
echo  Two set variables must be predefined before using this batch file:
echo.
echo   - installed Saxon 8 at: %%Saxon8Dir%%=%Saxon8Dir%
echo   - installed Ant at: %%AntDir%%=%AntDir%
echo   - invocation of Open Office at: %%OpenOfficeRun%%=%OpenOfficeRun%
echo.
echo  One set variable may be predefined before using this batch file:
echo.
echo   - identification string at: %%UBL2xsdID%%=%UBL2xsdID%
echo.

rem  $Id: filterXSDDK.bat,v 1.7 2006/12/21 20:54:43 G. Ken Holman Exp $
rem 
rem Implementation note:  more than 9 arguments need to be passed, but
rem Windows only supports addressing 9 other than the invocation.  This
rem batch file remembers information from each argument, and then uses it.
rem
rem This may have an excessive burden on the limited environment space,
rem so it may be necessary to increase the environment space.

goto :done
:start
if not exist %Saxon8Dir%saxon8.jar goto :missingSaxon
if not exist %AntDir%lib\ant-launcher.jar goto :missingAnt

rem  Determine each of the arguments
set              fXSDKBuild=%~dp0filterXSDDK.xml
if not "a%fXSDKBuild%" == "a%~dp0filterXSDDK.xml"    goto :noenv
set                 fXSDKsp=%1
if not           "a%fXSDKsp%"=="a%1"                goto :noenv
shift
set                 fXSDKdss=%1
if not           "a%fXSDKdss%"=="a%1"                goto :noenv
shift
set                fXSDKdssx=%1
if not          "a%fXSDKdssx%"=="a%1"                goto :noenv
shift
set                 fXSDKxin=%1
if not           "a%fXSDKxin%"=="a%1"                goto :noenv
shift
set                fXSDKxout=%1
if not          "a%fXSDKxout%"=="a%1"                goto :noenv
shift
set                fXSDKcomp=%1
if not          "a%fXSDKcomp%"=="a%1"                goto :noenv
shift
set                fXSDKwork=%1
if not          "a%fXSDKwork%"=="a%1"                goto :noenv
shift
set                fXSDKcopy=%1
if not          "a%fXSDKcopy%"=="a%1"                goto :noenv
shift
set                fXSDKregf=%1
if not          "a%fXSDKregf%"=="a%1"                goto :noenv
shift
set                fXSDKurif=%1
if not          "a%fXSDKurif%"=="a%1"                goto :noenv
shift
set                 fXSDKerr=%1
if not           "a%fXSDKerr%"=="a%1"                goto :noenv
rem last argument cannot be empty
if "a%1" == "a" goto :message
shift
rem after last argument must be empty
if not "a%1" == "a" goto :message

if not exist %Saxon8Dir%saxon8.jar goto :missingSaxon
if not exist %AntDir%lib\ant-launcher.jar goto :missingAnt

set                  fXSDKid=%UBL2xsdID%
if not            "a%fXSDKid%"=="a%UBL2xsdID%"                goto :noenv

echo Processing %fXSDKdoc%
java -Xms100m -Xmx200m -Dant.home=%AntDir% -cp "%Saxon8Dir%saxon8.jar;%AntDir%lib\ant-launcher.jar" org.apache.tools.ant.launch.Launcher -buildfile "%fXSDKBuild%" "-Dstrictpermitted=%fXSDKsp%" "-D%fXSDKdssx%=%fXSDKdss%.%fXSDKdssx%" "-Dxsdinfile=%fXSDKxin%" "-Dxsdoutfile=%fXSDKxout%" "-Dcomponent=%fXSDKcomp%" "-Dworkdir=%fXSDKwork%" "-DidentificationString=%fXSDKid%" "-Dcopyrightfile=%fXSDKcopy%" "-Dregexforeign=%fXSDKregf%" "-Dnsforeign=%fXSDKurif%" "-Derrorfile=%fXSDKerr%" "-Dsoffice=%OpenOfficeRun%" "-Dstartdir=%cd%" 1>filterXSDDK.err 2>&1

if %errorlevel% neq 0 more filterXSDDK.err >>%fXSDKerr%
del filterXSDDK.err
goto :done

:noenv
echo Insufficient environment space to set path variable
goto :done

:missingSaxon
echo Problem finding the installed Saxon 8 at: %%Saxon8Dir%%=%Saxon8Dir%
goto :done

:missingAnt
echo Problem finding the installed Ant at: %%AntDir%%=%AntDir%
goto :done

:done
rem Reclaim environment space
