<?xml version="1.0" encoding="US-ASCII"?>
<!--
     xmlUBL2nested.xsl - convert labeled XML from flat items to nested items

     This converts a flat set of <Item> elements into nested sets of
     <Item> elements under an <ABIE> element, using those <Item> elements
     that follow each <Item> whose ComponentType='ABIE'.

     $Id: oioUBL2nested.xsl,v 1.4 2006/11/06 08:31:52 G. Ken Holman Exp $

  Copyright (C) - Crane Softwrights Ltd.
 		- http://www.CraneSoftwrights.com/links/res-dev.htm
  Portions originally copyright (C) 2006 National IT and Telecom Agency, 
  Denmark, and used under the license by which these portions were obtained.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:
  
  - Redistributions of source code must retain the above copyright notice,
    this list of conditions and the following disclaimer.
  - Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
  - The name of the author may not be used to endorse or promote products
    derived from this software without specific prior written permission.
  
  THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN
  NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
  TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEG-
  LIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  
  Note: for reference, the above is the "Modified BSD license", this text
  was obtained 2003-07-26 at http://www.xfree86.org/3.3.6/COPYRIGHT2.html#5
 
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="2.0">

<xsl:output indent="yes" encoding="UTF-8"/>

<xsl:template match="/">
  <!--same document element as assumed is in input-->
  <Model>
    <!--group the rows by every item found to be an ABIE-->
    <xsl:for-each-group select="/*/Item" 
                  group-starting-with="Item[ComponentType='ABIE']">
      <!--nest the members of the group under a new element-->
      <ABIE>
        <!--copy these nodes-->
        <xsl:apply-templates select="current-group()[self::*]"/>
      </ABIE>
    </xsl:for-each-group>
  </Model>
</xsl:template>

<!--copy nodes in a piecemeal fashion so this stylesheet can be specialized-->
<xsl:template match="@*|*|text()">
  <xsl:copy>
    <xsl:apply-templates select="@*|*|text()"/>
  </xsl:copy>
</xsl:template>

<!--comments and processing instructions are ignored-->

</xsl:stylesheet>